---
layout: page
title: "OSC Strategic Grant Program - Self Assessment"
---

<h2>Self Assessment</h2>

<p>This self-assessment form is based on the OSC <a href="maturity-model.html">Maturity Model</a> for open source projects. Please complete this form for each product/project referenced in your proposal. The aim of this checklist is help portions of the scoring of the program's merit criteria, but is only a partial factor in the overall consideration.</p>
 <br/>

<fieldset>
<h3>Software Code</h3>

<ul>
   <input type="checkbox" name="softwarecore" value="CD10"/> The project produces Open Source software, for distribution to the public at no charge. </br>
   <input type="checkbox" name="softwarecore" value="CD20"/> The project's code is easily discoverable and publicly accessible.<br/>
   <input type="checkbox" name="softwarecore" value="CD21"/> The project's code uses mainstream revision control software, such as git.<br/>
   <input type="checkbox" name="softwarecore" value="CD30"/> The code can be built in a reproducible way using widely available standard tools.<br/>
   <input type="checkbox" name="softwarecore" value="CD31"/> Step-by-step instructions for setting up a developer environment is available for all appropriate platforms/operating systems, with a minimum of manual steps (e.g. running commands in a terminal/shell).<br/>
   <input type="checkbox" name="softwarecore" value="CD40"/> The full history of the project's code is available via a source code control system, in a way that allows any released version to be recreated.<br/>
   <input type="checkbox" name="softwarecore" value="CD50"/> The provenance of each line of code is established via the source code control system, in a reliable way based on strong authentication of the committer. When third-party contributions are committed, commit messages provide reliable information about the code provenance. <br/>
   <input type="checkbox" name="softwarecore" value="CD60"/> The code contains README, NOTICE, and CONTRIBUTING files (or README sections).<br/>
   <input type="checkbox" name="softwarecore" value="CD61"/> A process for claiming bugs is explained in the CONTRIBUTING documentation.<br/>
</fieldset>

<h3>Licenses and Copyright</h3>

<ul>
   <input type="checkbox" name="licenses" value="LC10"/> The code is released under one of the preferred copyleft licenses explained in our [Licensing Principles](licensing-principles).<br/>
   <input type="checkbox" name="licenses" value="LC20"/> Libraries that are mandatory dependencies of the project's code do not create more restrictions than the project's license does.  <br/>
   <input type="checkbox" name="licenses" value="LC30"/> The libraries mentioned in LC20 are available as Open Source software.<br/>
   <input type="checkbox" name="licenses" value="LC40"/> Committers are bound by an Individual Contributor Agreement (the ["Apache iCLA"](http://www.apache.org/licenses/icla.txt)_ being an example) that defines which code they are allowed to commit and how they need to identify code that is not their own.<br/>
   <input type="checkbox" name="licenses" value="LC50"/> The copyright ownership of everything that the project produces is clearly defined and documented. <br/>
   <input type="checkbox" name="licenses" value="LC60"/> The project name has been checked for trademark issues.<br/>
</ul>

<h3>Software Releases</h3>

<ul>
   <input type="checkbox" name="softwarereleases" value="RE10"/> Releases consist of source code, distributed using standard and open archive formats that are expected to stay readable in the long term. <br/>
   <input type="checkbox" name="softwarereleases" value="RE30"/> Releases are signed and/or distributed along with digests that can be reliably used to validate the downloaded archives.<br/>
   <input type="checkbox" name="softwarereleases" value="RE40"/> Convenience binaries can be distributed alongside source code but they are not official releases -- they are just a convenience provided with no guarantee.<br/>
   <input type="checkbox" name="softwarereleases" value="RE50"/> The release process is documented and repeatable to the extent that someone new to the project is able to independently generate the complete set of artifacts required for a release.<br/>
   <input type="checkbox" name="softwarereleases" value="RE60"/> Release plans are developed and executed in public by the community, and approved by the project's governing body.<br/>
   <input type="checkbox" name="softwarereleases" value="RE70"/> The project should use the OSC standard release taxonomy, once that is agreed upon.<br/>
   <input type="checkbox" name="softwarereleases" value="RE80"/> The project has released at least one version.<br/>
</ul>

<h3>Software Quality</h3>

<ul>
   <input type="checkbox" name="softwarequality" value="QU10"/> The project is open and honest about the quality of its code. Various levels of quality and maturity for various modules are natural and acceptable as long as they are clearly communicated.<br/>
   <input type="checkbox" name="softwarequality" value="QU11"/> In particular, there are either no "monoliths" or "god classes," or they are known and there is a roadmap to refactor them.<br/>
   <input type="checkbox" name="softwarequality" value="QU12"/> In particular, there are no custom utility features that could be replaced with common open source tools, including:<ul>
    <li>Databases<br/>
    <li>Web application servers/containers<br/>
    <li>Object relational mappers<br/>
    <li>Dependency/package management<br/>
    <li>Authentication<br/>
    <li>Continuous integration<br/>
    <li>Packaging/installation<br/>
   </ul><br/>
   <input type="checkbox" name="softwarequality" value="QU20"/> The project puts a very high priority on producing secure software. <br/>
   <input type="checkbox" name="softwarequality" value="QU30"/> The project provides a well-documented channel to report security issues, along with a documented way of responding to them. <br/>
   <input type="checkbox" name="softwarequality" value="QU40"/> The project puts a high priority on backwards compatibility and aims to document any incompatible changes and provide tools and documentation to help users transition to new features.<br/>
   <input type="checkbox" name="softwarequality" value="QU50"/> The project strives to respond to documented bug reports in a timely manner.<br/>
   <input type="checkbox" name="softwarequality" value="QU51"/> A list of outstanding bugs is open, easily discoverable, prioritized, and responsively triaged.<br/>
   <input type="checkbox" name="softwarequality" value="QU52"/> Bugs that are ideal for new contributors are labeled as such.<br/>
   <input type="checkbox" name="softwarequality" value="QU60"/> The project must include a unit and integration test suite of sufficient  coverage, and must document its coverage. Additional performance and scale test capability is desirable.<br/>
   <input type="checkbox" name="softwarequality" value="QU70"/> The project must include enough documentation for anyone to test or deploy any of the software.<br/>
   <input type="checkbox" name="softwarequality" value="QU71"/> The project must include enough documentation for a software developer of moderate skill to set up their development environment to contribute to the software code.<br/>
   <input type="checkbox" name="softwarequality" value="QU80"/> The project must document how it integrates with other OSC Member (or external) projects. Where applicable, the project should be compatible with other active projects.<br/>
   <input type="checkbox" name="softwarequality" value="QU90"/> The project has set up a Continuous Integration pipeline for testing and deployment purposes.<br/>
   <input type="checkbox" name="softwarequality" value="QU100"/> The project must demonstrate sufficient scalability and document its scalability over various dimensions appropriate to the project.<br/>
</ul>

<h3>Community</h3>

<ul>
   <input type="checkbox" name="community" value="CO10"/> The project has a well-known homepage that points to all the information required to operate according to this maturity model.<br/>
   <input type="checkbox" name="community" value="CO20"/> The community welcomes contributions from anyone who acts in good faith and in a respectful manner and adds value to the project.<br/>
   <input type="checkbox" name="community" value="CO30"/> Contributions include not only source code, but also documentation, constructive bug reports, constructive discussions, marketing and generally anything that adds value to the project.<br/>
   <input type="checkbox" name="community" value="CO40"/> The community is a "holarchy" (see [Governance Principles](governance-principles)) and over time aims to give more rights and responsibilities to contributors who add value to the project.<br/>
   <input type="checkbox" name="community" value="CO50"/> The way in which contributors can be granted more rights such as commit access or decision power is clearly documented and is the same for all contributors.<br/>
   <input type="checkbox" name="community" value="CO60"/> The community operates based on consensus of its members (see CS10) who have decision power. Dictators, benevolent or not, are not welcome in Apache projects.<br/>
   <input type="checkbox" name="community" value="CO70"/> The project strives to answer user questions in a timely manner.<br/>
   <input type="checkbox" name="community" value="CO71"/> The project has a well-known real-time communication platform such as IRC.<br/>
   <input type="checkbox" name="community" value="CO72"/> The project's real-time communications are archived so that users can refer back to past conversations.<br/>
   <input type="checkbox" name="community" value="CO73"/> The community has a forum or other discussion platform for users to ask questions, with reasonable response times from the community.<br/>
   <input type="checkbox" name="community" value="CO80"/> The project has an active and diverse set of contributing members representing various constituencies.<br/>
</ul>

<h3>Consensus Building</h3>

<ul>
   <input type="checkbox" name="consensusbuilding" value="CS10"/> The project maintains a public list of its contributors who have decision power and some sort of documented governance process.<br/>
   <input type="checkbox" name="consensusbuilding" value="CS20"/> Decisions are made by consensus among PMC members  and are documented on the project's main communications channel. Community opinions are taken into account but the PMC has the final word if needed.<br/>
   <input type="checkbox" name="consensusbuilding" value="CS30"/> Documented voting rules are used to build consensus when discussion is not sufficient. <br/>
   <input type="checkbox" name="consensusbuilding" value="CS40"/> In Apache projects, vetoes are only valid for code commits and are justified by a technical explanation, as per the Apache voting rules defined in CS30.<br/>
   <input type="checkbox" name="consensusbuilding" value="CS50"/> All "important" discussions happen asynchronously in written form on the project's main communications channel. Offline, face-to-face or private discussions  that affect the project are also documented on that channel.<br/>
</ul>

<h3>Independence</h3>

<ul>
   <input type="checkbox" name="independence" value="IN10"/> The project is independent from any corporate or organizational influence. <br/>
   <input type="checkbox" name="independence" value="IN20"/> Contributors act as themselves as opposed to representatives of a corporation or organization.<br/>
   <input type="checkbox" name="independence" value="IN30"/> The project is not highly dependent on any single contributor. There are at least 3 legally independent contributors (e.g., code committers), and there is no single organization that is vital to the success of the project.<br/>
</ul>

<h3>Impact</h3>

<ul>
   <input type="checkbox" name="impact" value="IM10"/> The project should be used in real applications and not just in demos. Because not all real-world implementations may be inspected publicly, in such cases statements providing as much details as possible about these implementations should be made.<br/>
   <input type="checkbox" name="impact" value="IM20"/> The project should be able to clearly make the case for its importance in the Development and/or Humanitarian sector(s).<br/>
</ul>
